// vim:expandtab:shiftwidth=2:tabstop=2:
// Copyright (C) 2013 Canonical Ltd.

// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

#ifndef _OXIDE_QT_CORE_GLUE_PRIVATE_WEB_FRAME_ADAPTER_H_
#define _OXIDE_QT_CORE_GLUE_PRIVATE_WEB_FRAME_ADAPTER_H_

#include <QList>

#include "base/basictypes.h"
#include "base/compiler_specific.h"

namespace oxide {
namespace qt {

class OutgoingMessageRequestAdapter;
class WebFrame;
class WebFrameAdapter;

class WebFrameAdapterPrivate FINAL {
 public:
  WebFrameAdapterPrivate();
  ~WebFrameAdapterPrivate();

  const QList<OutgoingMessageRequestAdapter *>& outgoing_message_requests() const {
    return outgoing_message_requests_;
  }

  void AddOutgoingMessageRequest(OutgoingMessageRequestAdapter* request);
  void RemoveOutgoingMessageRequest(OutgoingMessageRequestAdapter* request);

  static WebFrameAdapterPrivate* get(WebFrameAdapter* adapter);

  WebFrame* owner;

 private:
  QList<OutgoingMessageRequestAdapter *> outgoing_message_requests_;

  DISALLOW_COPY_AND_ASSIGN(WebFrameAdapterPrivate);
};

} // namespace qt
} // namespace oxide

#endif // _OXIDE_QT_CORE_GLUE_PRIVATE_WEB_FRAME_ADAPTER_H_
